;(function( fop2chatbroker, undefined) {

  var page = '';
  var bubble_color = '#1f2937';
  var text_color = '#ffffff';
  var lang = 'en';
  var fingerprint = '';
  var chatInput;
  var chatSubmit;
  var chatMessages;
  var chatBubble;
  var chatPopup;
  var closePopup;
  var chatNew;
  var chatCopy;
  var name='';
  var email='';
  var realtime_url='';
  var chat_disabled=0;

  var text = {};
  text['en']={};
  text['es']={};
  text['en']['contact_intro']='Please fill out the form below to start chatting with the next available agent.';
  text['en']['full_name']='Your full name';
  text['en']['email']='Your email';
  text['en']['start_chat']='Start Chat';
  text['en']['type']='Type your message...';
  text['en']['send']='Send';
  text['en']['you']='You';
  text['en']['agent']='Agent';
  text['en']['copychat']='Copy conversation';
  text['en']['newchat']='New conversation';

  text['es']['contact_intro']='Rellene el siguiente formulario para empezar a chatear con el siguiente agente disponible.';
  text['es']['full_name']='Su nombre completo';
  text['es']['email']='Su email';
  text['es']['start_chat']='Iniciar Chat';
  text['es']['type']='Escriba su mensaje...';
  text['es']['send']='Enviar';
  text['es']['you']='Usted';
  text['es']['agent']='Agente';
  text['es']['copychat']='Copiar conversación';
  text['es']['newchat']='Nueva conversación';

  const loadScript = (FILE_URL, async = true, type = "text/javascript") => {
      return new Promise((resolve, reject) => {
          try {
              const scriptEle = document.createElement("script");
              scriptEle.type = type;
              scriptEle.async = async;
              scriptEle.src =FILE_URL;
              scriptEle.addEventListener("load", (ev) => {
                  resolve({ status: true });
              });
              scriptEle.addEventListener("error", (ev) => {
                  reject({
                      status: false,
                      message: `Failed to load the script ＄{FILE_URL}`
                  });
              });
              document.body.appendChild(scriptEle);
          } catch (error) {
              reject(error);
          }
      });
  };

;(function(name,context,definition) { if (typeof module !== 'undefined' && module.exports) { module.exports = definition(); } else if (typeof define === 'function' && define.amd) { define(definition); } else { context[name] = definition(); } } ) ('Fingerprint', this, function() { 'use strict'; var Fingerprint = function(options) { var nativeForEach, nativeMap; nativeForEach = Array.prototype.forEach; nativeMap = Array.prototype.map; this.each = function(obj, iterator, context) { if (obj === null) { return; } if (nativeForEach && obj.forEach === nativeForEach) { obj.forEach(iterator, context); } else if (obj.length === +obj.length) { for (var i = 0, l = obj.length; i < l; i++) { if (iterator.call(context, obj[i], i, obj) === {}) return; } } else { for (var key in obj) { if (obj.hasOwnProperty(key)) { if (iterator.call(context, obj[key], key, obj) === {}) return; } } } }; this.map = function(obj, iterator, context) { var results = []; if (obj == null) return results; if (nativeMap && obj.map === nativeMap) return obj.map(iterator, context); this.each(obj, function(value, index, list) { results[results.length] = iterator.call(context, value, index, list); }); return results; }; if (typeof options == 'object') { this.hasher = options.hasher; this.screen_resolution = options.screen_resolution; this.screen_orientation = options.screen_orientation; this.canvas = options.canvas; this.ie_activex = options.ie_activex; } else if (typeof options == 'function') { this.hasher = options; } }; Fingerprint.prototype = { get: function() { var keys = []; keys.push(navigator.userAgent); keys.push(navigator.language); keys.push(screen.colorDepth); if (this.screen_resolution) { var resolution = this.getScreenResolution(); if (typeof resolution !== 'undefined') { keys.push(this.getScreenResolution().join('x')); } } keys.push(new Date().getTimezoneOffset()); keys.push(this.hasSessionStorage()); keys.push(this.hasLocalStorage()); keys.push(!!window.indexedDB); if (document.body) { keys.push(typeof(document.body.addBehavior)); } else { keys.push(typeof undefined); } keys.push(typeof(window.openDatabase)); keys.push(navigator.cpuClass); keys.push(navigator.platform); keys.push(navigator.doNotTrack); keys.push(this.getPluginsString()); if (this.canvas && this.isCanvasSupported()) { keys.push(this.getCanvasFingerprint()); } if (this.hasher) { return this.hasher(keys.join('###'), 31); } else { return this.murmurhash3_32_gc(keys.join('###'), 31); } }, murmurhash3_32_gc: function(key, seed) { var remainder, bytes, h1, h1b, c1, c2, k1, i; remainder = key.length & 3; bytes = key.length - remainder; h1 = seed; c1 = 0xcc9e2d51; c2 = 0x1b873593; i = 0; while (i < bytes) { k1 = ((key.charCodeAt(i) & 0xff)) | ((key.charCodeAt(++i) & 0xff) << 8) | ((key.charCodeAt(++i) & 0xff) << 16) | ((key.charCodeAt(++i) & 0xff) << 24); ++i; k1 = ((((k1 & 0xffff) * c1) + ((((k1 >>> 16) * c1) & 0xffff) << 16))) & 0xffffffff; k1 = (k1 << 15) | (k1 >>> 17); k1 = ((((k1 & 0xffff) * c2) + ((((k1 >>> 16) * c2) & 0xffff) << 16))) & 0xffffffff; h1 ^= k1; h1 = (h1 << 13) | (h1 >>> 19); h1b = ((((h1 & 0xffff) * 5) + ((((h1 >>> 16) * 5) & 0xffff) << 16))) & 0xffffffff; h1 = (((h1b & 0xffff) + 0x6b64) + ((((h1b >>> 16) + 0xe654) & 0xffff) << 16)); } k1 = 0; switch (remainder) { case 3: k1 ^= (key.charCodeAt(i + 2) & 0xff) << 16; case 2: k1 ^= (key.charCodeAt(i + 1) & 0xff) << 8; case 1: k1 ^= (key.charCodeAt(i) & 0xff); k1 = (((k1 & 0xffff) * c1) + ((((k1 >>> 16) * c1) & 0xffff) << 16)) & 0xffffffff; k1 = (k1 << 15) | (k1 >>> 17); k1 = (((k1 & 0xffff) * c2) + ((((k1 >>> 16) * c2) & 0xffff) << 16)) & 0xffffffff; h1 ^= k1; } h1 ^= key.length; h1 ^= h1 >>> 16; h1 = (((h1 & 0xffff) * 0x85ebca6b) + ((((h1 >>> 16) * 0x85ebca6b) & 0xffff) << 16)) & 0xffffffff; h1 ^= h1 >>> 13; h1 = ((((h1 & 0xffff) * 0xc2b2ae35) + ((((h1 >>> 16) * 0xc2b2ae35) & 0xffff) << 16))) & 0xffffffff; h1 ^= h1 >>> 16; return h1 >>> 0; }, hasLocalStorage: function() { try { return !!window.localStorage; } catch (e) { return true; } }, hasSessionStorage: function() { try { return !!window.sessionStorage; } catch (e) { return true; } }, isCanvasSupported: function() { var elem = document.createElement('canvas'); return !!(elem.getContext && elem.getContext('2d')); }, isIE: function() { if (navigator.appName === 'Microsoft Internet Explorer') { return true; } else if (navigator.appName === 'Netscape' && /Trident/.test(navigator.userAgent)) { return true; } return false; }, getPluginsString: function() { if (this.isIE() && this.ie_activex) { return this.getIEPluginsString(); } else { return this.getRegularPluginsString(); } }, getRegularPluginsString: function() { return this.map(navigator.plugins, function(p) { var mimeTypes = this.map(p, function(mt) { return [mt.type, mt.suffixes].join('~'); }).join(','); return [p.name, p.description, mimeTypes].join('::'); }, this).join(';'); }, getIEPluginsString: function() { if (window.ActiveXObject) { var names = ['ShockwaveFlash.ShockwaveFlash', 'AcroPDF.PDF', 'PDF.PdfCtrl', 'QuickTime.QuickTime', 'rmocx.RealPlayer G2 Control', 'rmocx.RealPlayer G2 Control.1', 'RealPlayer.RealPlayer(tm) ActiveX Control (32-bit)', 'RealVideo.RealVideo(tm) ActiveX Control (32-bit)', 'RealPlayer', 'SWCtl.SWCtl', 'WMPlayer.OCX', 'AgControl.AgControl', 'Skype.Detection' ]; return this.map(names, function(name) { try { new ActiveXObject(name); return name; } catch (e) { return null; } }).join(';'); } else { return ""; } }, getScreenResolution: function() { var resolution; if (this.screen_orientation) { resolution = (screen.height > screen.width) ? [screen.height, screen.width] : [screen.width, screen.height]; } else { resolution = [screen.height, screen.width]; } return resolution; }, getCanvasFingerprint: function() { var canvas = document.createElement('canvas'); var ctx = canvas.getContext('2d'); var txt = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!@#$%^&*()_+-={}|[]\:"<>?;,.'; ctx.textBaseline = "top"; ctx.font = "14px 'Arial'"; ctx.textBaseline = "alphabetic"; ctx.fillStyle = "#f60"; ctx.fillRect(125, 1, 62, 20); ctx.fillStyle = "#069"; ctx.fillText(txt, 2, 15); ctx.fillStyle = "rgba(102, 204, 0, 0.7)"; ctx.fillText(txt, 4, 17); return canvas.toDataURL(); } }; return Fingerprint;});

  fop2chatbroker.Setup = function(data) {
      page = data.page;
      page = page.toLowerCase();
      if(data.lang!==undefined) {
          lang = data.lang;
      }
      if(data.bubble_color!==undefined) {
          bubble_color = data.bubble_color;
      }
      if(data.text_color!==undefined) {
          text_color = data.text_color;
      }
  }

  var fingerprint = "";

  // Inject the CSS
  const style = document.createElement('style');
  style.innerHTML = `
.all-y4M48UwqUx8k8i,::after,::before{box-sizing:border-box;border-width:0;border-style:solid;border-color: currentColor;}
.hidden-y4M48UwqUx8k8i{display:none !important;}
button.y4M48UwqUx8k8i,input.y4M48UwqUx8k8i{font-family:inherit !important;font-size:100% !important;line-height:1.15 !important;margin:0 !important;}
button.y4M48UwqUx8k8i{text-transform:none !important;}
button.y4M48UwqUx8k8i{background-color:transparent;background-image:none;}
input.y4M48UwqUx8k8i::placeholder{opacity:1;color:#9ca3af;}
input.y4M48UwqUx8k8i{padding:.5em !important;}
button.y4M48UwqUx8k8i{cursor:pointer;}
button.y4M48UwqUx8k8i,input.y4M48UwqUx8k8i{padding:0;line-height:inherit;color:inherit;}
svg.y4M48UwqUx8k8i{display:block;vertical-align:middle;}
h3.y4M48UwqUx8k8i{font-size:1.125rem;font-weight:inherit;margin:0}
.y4M48UwqUx8k8i,::after,::before{--y4M48UwqUx8k8i-border-opacity:1;border-color:rgba(229,231,235,var(--y4M48UwqUx8k8i-border-opacity));}
.absolute-y4M48UwqUx8k8i{position:absolute;}
.right-0-y4M48UwqUx8k8i{right:0;}
.bottom-20-y4M48UwqUx8k8i{bottom:5rem;}
.m-0-y4M48UwqUx8k8i{margin:0;}
.mb-2-y4M48UwqUx8k8i{margin-bottom:.5rem;}
.mb-6-y4M48UwqUx8k8i{margin-bottom:1.5rem;}
.block-y4M48UwqUx8k8i{display:block;}
.flex-y4M48UwqUx8k8i{display:flex;}
.h-6-y4M48UwqUx8k8i{height:1.5rem;}
.h-10-y4M48UwqUx8k8i{height:2.5rem;}
.h-16-y4M48UwqUx8k8i{height:4rem;}
.w-6-y4M48UwqUx8k8i{width:1.5rem;}
.w-10-y4M48UwqUx8k8i{width:2.5rem;}
.w-16-y4M48UwqUx8k8i{width:4rem;}
.w-96-y4M48UwqUx8k8i{width:24rem;}
.w-34-y4M48UwqUx8k8i{width:75%;}
.w-full-y4M48UwqUx8k8i{width:100%;}
.flex-1-y4M48UwqUx8k8i{flex:1 1 0%;}
.cursor-pointer-y4M48UwqUx8k8i{cursor:pointer;}
.flex-col-y4M48UwqUx8k8i{flex-direction:column;}
.items-centery-y4M48UwqUx8k8i{align-items:center;}
.justify-center-y4M48UwqUx8k8i{justify-content:center;}
.justify-between-y4M48UwqUx8k8i{justify-content:space-between;}
.space-x-4-y4M48UwqUx8k8i>:not([hidden])~:not([hidden]){--y4M48UwqUx8k8i-space-x-reverse:0;margin-right:calc(1rem * var(--y4M48UwqUx8k8i-space-x-reverse));margin-left:calc(1rem * calc(1 - var(--y4M48UwqUx8k8i-space-x-reverse)));}
.rounded-md-y4M48UwqUx8k8i{border-radius:.375rem;}
.rounded-lg-y4M48UwqUx8k8i{border-radius:.5rem;}
.rounded-full-y4M48UwqUx8k8i{border-radius:9999px;}
.rounded-t-md-y4M48UwqUx8k8i{border-top-left-radius:.375rem !important;border-top-right-radius:.375rem !important;}
.border-y4M48UwqUx8k8i{border-width:1px !important;}
.border-t-y4M48UwqUx8k8i{border-top-width:1px !important;}
.border-none-y4M48UwqUx8k8i-y4M48UwqUx8k8i{border-style:none !important;}
.border-gray-200-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-border-opacity:1;border-color:rgba(229,231,235,var(--y4M48UwqUx8k8i-border-opacity)) !important;}
.border-gray-300-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-border-opacity:1;border-color:rgba(209,213,219,var(--y4M48UwqUx8k8i-border-opacity)) !important;}
.bg-transparent-y4M48UwqUx8k8i{background-color:transparent;}
.bg-white-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-bg-opacity:1;background-color:rgba(255,255,255,var(--y4M48UwqUx8k8i-bg-opacity)) !important;}
.bg-gray-50-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-bg-opacity:1;background-color:rgba(249,250,251,var(--y4M48UwqUx8k8i-bg-opacity)) !important;}
.bg-gray-800-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-bg-opacity:1;background-color:rgba(31,41,55,var(--y4M48UwqUx8k8i-bg-opacity)) !important;}
.bg-blue-700-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-bg-opacity:1;background-color:rgba(29,78,216,var(--y4M48UwqUx8k8i-bg-opacity)) !important;}
.p-4-y4M48UwqUx8k8i{padding:1rem !important;}
.p-8-y4M48UwqUx8k8i{padding:2rem !important;}
.p-25-y4M48UwqUx8k8i{padding:.625rem !important;}
.px-4-y4M48UwqUx8k8i{padding-left:1rem;padding-right:1rem;}
.px-5-y4M48UwqUx8k8i{padding-left:1.25rem !important;padding-right:1.25rem !important;}
.py-2-y4M48UwqUx8k8i{padding-top:.5rem !important;padding-bottom:.5rem !important;}
.py-25-y4M48UwqUx8k8i{padding-top:.625rem !important;padding-bottom:.625rem !important;}
.pt-4-y4M48UwqUx8k8i{padding-top:1rem !important;}
.text-center-y4M48UwqUx8k8i{text-align:center !important;}
.text-xs-y4M48UwqUx8k8i{font-size:.75rem !important;line-height:1rem !important;}
.text-sm-y4M48UwqUx8k8i{font-size:.875rem !important;line-height:1.25rem !important;}
.text-lg-y4M48UwqUx8k8i{font-size:1.125rem !important;line-height:1.75rem;}
.text-3xl-y4M48UwqUx8k8i{font-size:1.875rem !important;line-height:2.25rem;}
.font-medium-y4M48UwqUx8k8i{font-weight:500;}
.text-white-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-text-opacity:1;color:rgba(255,255,255,var(--y4M48UwqUx8k8i-text-opacity)) !important;}
.text-red-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-text-opacity:1;color:rgba(200,15,15,var(--y4M48UwqUx8k8i-text-opacity)) !important;}
.text-gray-900-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-text-opacity:1;color:rgba(17,24,39,var(--y4M48UwqUx8k8i-text-opacity)) !important;}
y4M48UwqUx8k8i,::after,::before{--y4M48UwqUx8k8i-shadow:0 0 #0000;}
.shadow-md-y4M48UwqUx8k8i{--y4M48UwqUx8k8i-shadow:0 4px 6px -1px rgba(0, 0, 0, 0.1),0 2px 4px -1px rgba(0, 0, 0, 0.06);box-shadow:var(--y4M48UwqUx8k8i-ring-offset-shadow,0 0 #0000),var(--y4M48UwqUx8k8i-ring-shadow,0 0 #0000),var(--y4M48UwqUx8k8i-shadow);}
.outline-none-y4M48UwqUx8k8i-y4M48UwqUx8k8i{outline:2px solid transparent;outline-offset:2px;}
y4M48UwqUx8k8i,::after,::before{--y4M48UwqUx8k8i-ring-inset:var(--y4M48UwqUx8k8i-empty, );--y4M48UwqUx8k8i-ring-offset-width:0px;--y4M48UwqUx8k8i-ring-offset-color:#fff;--y4M48UwqUx8k8i-ring-color:rgba(59, 130, 246, 0.5);--y4M48UwqUx8k8i-ring-offset-shadow:0 0 #0000;--y4M48UwqUx8k8i-ring-shadow:0 0 #0000;}
.transition-all-y4M48UwqUx8k8i{transition-property:all;transition-timing-function:cubic-bezier(0.4,0,0.2,1);transition-duration:150ms;}
@media (min-width:640px){
.smw-auto-y4M48UwqUx8k8i{width:auto;}
}
#chat-widget-container-y4M48UwqUx8k8i{position:fixed;bottom:20px;right:20px;flex-direction:column;z-index:1000;}
#chat-popup-y4M48UwqUx8k8i{height:70vh;max-height:70vh;transition:all 0.3s;overflow:hidden;font-family:system-ui,-apple-system,'Segoe UI',Roboto,Helvetica,Arial,sans-serif,'Apple Color Emoji','Segoe UI Emoji';font-size:1em;}
@media (max-width: 768px){
#chat-popup-y4M48UwqUx8k8i{position:fixed;top:0;right:0;bottom:0;left:0;width:100%;height:100%;max-height:100%;border-radius:0;}
}
/**,*::before{box-sizing:border-box;}*/
#close-popup-y4M48UwqUx8k8i {padding:0;width:1em;}
#chat-submit-y4M48UwqUx8k8i{padding:0.5rem;line-height:1.2rem;min-height:1.2rem;max-width:100px;font-weight:700;text-transform:none;border:none;cursor:pointer;border-radius:5px;}
.contact-y4M48UwqUx8k8i{padding:1em;display:none;}
.chat-y4M48UwqUx8k8i{display:flex;flex-direction:column-reverse;height:100%;_border:1px #9bc dashed;font:1rem/1.5 "Open Sans", Arial;padding-bottom:2px;color:#313131;position:relative;overflow-y:scroll;overflow-x:hidden;}
.chat-y4M48UwqUx8k8i::before{content:"";position:absolute;z-index:1;top:0;height:40%;width:100%;_background:linear-gradient(to bottom, white 20%, rgba(255, 255, 255, 0)) repeat-x;}
.chat__inner-y4M48UwqUx8k8i{display:flex;flex-direction:column;padding:0.75rem;}
.chat-y4M48UwqUx8k8i p {margin:0;padding:0;}
.chat-y4M48UwqUx8k8i p {margin:0;padding:0;}
.chat__message-y4M48UwqUx8k8i{width:100%;display:flex;align-items:flex-end;transform-origin:0 100%;padding-top:0;transform:scale(0);max-height:0;overflow:hidden;animation:message 0.15s ease-out 0s forwards;animation-delay:var(--timeline);--bgcolor:#d8d8d8;--radius:12px 12px 12px 0;}
.chat__message_B-y4M48UwqUx8k8i{flex-direction:row-reverse;text-align:right;width:100%;align-self:flex-end;transform-origin:100%100%;--bgcolor:#d2ecd4;--radius:12px 12px 0 12px;}
._chat__message-y4M48UwqUx8k8i::before{content:"";flex:0040px;aspect-ratio:1/1;background:var(--bgcolor);border-radius:50%;}
.chat__content-y4M48UwqUx8k8i{flex:01auto;padding:1rem;margin:00.5rem;background:var(--bgcolor);border-radius:var(--radius);}
@keyframes message { 0% {max-height:100vmax;} 80% {transform:scale(1.1);} 100% {transform:scale(1);max-height:100vmax;overflow:visible;padding-top:1rem;}}
  `;

  document.head.appendChild(style);

  const hook_path = document.currentScript.src.substring(0, document.currentScript.src.lastIndexOf("/"));
  var url = new URL(hook_path);
  realtime_url = url.origin+"/realtime";

  const blip = new Audio(hook_path+"/blip.mp3");

  loadScript(hook_path+"/pocketbase.umd.js").then( data  => {
      injectWidget();
      bubble_container = document.getElementById('chat-bubble-y4M48UwqUx8k8i');
      header_container = document.getElementById('chat-header-y4M48UwqUx8k8i');
      submit_container = document.getElementById('chat-submit-y4M48UwqUx8k8i');

      bubble_text_element = document.getElementById('chat-bubble-y4M48UwqUx8k8i');
      header_text_element = document.getElementById('chat-header-text-y4M48UwqUx8k8i');
      close_text_element = document.getElementById('close-popup-y4M48UwqUx8k8i');

      bubble_container.style.backgroundColor = bubble_color;
      header_container.style.backgroundColor = bubble_color;
      submit_container.style.backgroundColor = bubble_color;

      submit_container.style.color = text_color;
      header_text_element.style.color = text_color;
      close_text_element.style.color = text_color;

      fingerprint = new Fingerprint().get();
      dita = { newchat: fingerprint, page: page };
      fetch(hook_path+'/helper.php', {
          method: 'POST',
          body: JSON.stringify(dita)
      })
      .then(response=>response.json())
      .then(function(response) {
          bubble_icon = document.getElementById('chat-bubble-icon-svg-y4M48UwqUx8k8i');
          if(response.id) {
             bubble_icon.style.color = text_color;
             const chatContact = document.getElementById('contact-y4M48UwqUx8k8i');
             const chatChat = document.getElementById('chat-y4M48UwqUx8k8i');
             const chatInputContainer = document.getElementById('chat-input-container-y4M48UwqUx8k8i');
             name = response.name;
             email = response.email;
             if(response.id=='none') {
                 // ask for contact info
                 chatContact.style.display = 'block';
                 chatChat.style.display = 'none';
                 chatInputContainer.style.display = 'none';
             } else {
                 chatContact.style.display = 'none';
                 chatChat.style.display = 'flex';
                 //chatInputContainter.style.display = 'block';
                 connect_subscribe(response.id,response.domain);
             }
        } else {
            bubble_icon.style.color="#DD1111";
            chat_disabled=1;
            console.error("Error");
        }
      });
  })
  .catch( err => {
        console.error(err);
  });


  function injectWidget() {
      // Create chat widget container
      const chatWidgetContainer = document.createElement('div');
      chatWidgetContainer.id = 'chat-widget-container-y4M48UwqUx8k8i';
      document.body.appendChild(chatWidgetContainer);

      // Inject the HTML
      chatWidgetContainer.innerHTML = `
        <div id="chat-bubble-y4M48UwqUx8k8i" style="background-color: #ddd;" class="all-y4M48UwqUx8k8i w-16-y4M48UwqUx8k8i h-16-y4M48UwqUx8k8i xbg-gray-800-y4M48UwqUx8k8i rounded-full-y4M48UwqUx8k8i flex-y4M48UwqUx8k8i items-centery-y4M48UwqUx8k8i justify-center-y4M48UwqUx8k8i cursor-pointer-y4M48UwqUx8k8i text-3xl-y4M48UwqUx8k8i">
          <svg xmlns="http://www.w3.org/2000/svg" id="chat-bubble-icon-svg-y4M48UwqUx8k8i" class="y4M48UwqUx8k8i w-10-y4M48UwqUx8k8i h-10-y4M48UwqUx8k8i" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
            <path stroke-linecap="round" stroke-linejoin="round" d="M8 10h.01M12 10h.01M16 10h.01M9 16H5a2 2 0 01-2-2V6a2 2 0 012-2h14a2 2 0 012 2v8a2 2 0 01-2 2h-5l-5 5v-5z" />
          </svg>
        </div>
        <div id="chat-popup-y4M48UwqUx8k8i" class="all-y4M48UwqUx8k8i hidden-y4M48UwqUx8k8i absolute-y4M48UwqUx8k8i bottom-20-y4M48UwqUx8k8i right-0-y4M48UwqUx8k8i w-96-y4M48UwqUx8k8i bg-white-y4M48UwqUx8k8i rounded-md-y4M48UwqUx8k8i shadow-md-y4M48UwqUx8k8i flex-y4M48UwqUx8k8i flex-col-y4M48UwqUx8k8i transition-all-y4M48UwqUx8k8i text-sm-y4M48UwqUx8k8i">
          <div id="chat-header-y4M48UwqUx8k8i" class="all-y4M48UwqUx8k8i flex-y4M48UwqUx8k8i justify-between-y4M48UwqUx8k8i items-centery-y4M48UwqUx8k8i p-4-y4M48UwqUx8k8i text-white-y4M48UwqUx8k8i rounded-t-md-y4M48UwqUx8k8i">
            <h3 class="y4M48UwqUx8k8i all-y4M48UwqUx8k8i m-0-y4M48UwqUx8k8i text-lg-y4M48UwqUx8k8i" id="chat-header-text-y4M48UwqUx8k8i">Chat</h3>
            <button id="close-popup-y4M48UwqUx8k8i" class="y4M48UwqUx8k8i all-y4M48UwqUx8k8i bg-transparent-y4M48UwqUx8k8i border-none-y4M48UwqUx8k8i cursor-pointer-y4M48UwqUx8k8i">
              <svg xmlns="http://www.w3.org/2000/svg" class="y4M48UwqUx8k8i h-6-y4M48UwqUx8k8i w-6-y4M48UwqUx8k8i" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
                <path stroke-linecap="round" stroke-linejoin="round" d="M6 18L18 6M6 6l12 12" />
              </svg>
            </button>
          </div>
          <section class="contact-y4M48UwqUx8k8i all-y4M48UwqUx8k8i" id="contact-y4M48UwqUx8k8i">
             <p class="all-y4M48UwqUx8k8i">${text[lang]['contact_intro']}</p>
             <form id="contactform-y4M48UwqUx8k8i">
               <div class="all-y4M48UwqUx8k8i mb-6-y4M48UwqUx8k8i">
                 <label for="fullname" class="all-y4M48UwqUx8k8i block-y4M48UwqUx8k8i mb-2-y4M48UwqUx8k8i text-sm-y4M48UwqUx8k8i font-medium-y4M48UwqUx8k8i text-gray-900-y4M48UwqUx8k8i">${text[lang]['full_name']}</label>
                 <input type="fullname" id="fullname-y4M48UwqUx8k8i" class="y4M48UwqUx8k8i all-y4M48UwqUx8k8i bg-gray-50-y4M48UwqUx8k8i border-y4M48UwqUx8k8i border-gray-300-y4M48UwqUx8k8i text-gray-900-y4M48UwqUx8k8i text-sm-y4M48UwqUx8k8i rounded-lg-y4M48UwqUx8k8i block-y4M48UwqUx8k8i w-full-y4M48UwqUx8k8i p-25-y4M48UwqUx8k8i" required>
               </div>
               <div class="all-y4M48UwqUx8k8i mb-6-y4M48UwqUx8k8i">
                 <label for="email" class="all-y4M48UwqUx8k8i block-y4M48UwqUx8k8i mb-2-y4M48UwqUx8k8i text-sm-y4M48UwqUx8k8i font-medium-y4M48UwqUx8k8i text-gray-900-y4M48UwqUx8k8i">${text[lang]['email']}</label>
                 <input type="email" id="email-y4M48UwqUx8k8i" class="y4M48UwqUx8k8i all-y4M48UwqUx8k8i bg-gray-50-y4M48UwqUx8k8i border-y4M48UwqUx8k8i border-gray-300-y4M48UwqUx8k8i text-gray-900-y4M48UwqUx8k8i text-sm-y4M48UwqUx8k8i rounded-lg-y4M48UwqUx8k8i block-y4M48UwqUx8k8i w-full-y4M48UwqUx8k8i p-25-y4M48UwqUx8k8i" placeholder="name@domain.com" required>
               </div>
               <button type="submit" class="y4M48UwqUx8k8i all-y4M48UwqUx8k8i text-white-y4M48UwqUx8k8i bg-blue-700-y4M48UwqUx8k8i font-medium-y4M48UwqUx8k8i rounded-lg-y4M48UwqUx8k8i text-sm-y4M48UwqUx8k8i w-full-y4M48UwqUx8k8i smw-auto-y4M48UwqUx8k8i px-5-y4M48UwqUx8k8i py-25-y4M48UwqUx8k8i text-center-y4M48UwqUx8k8i">${text[lang]['start_chat']}</button>
             </form>
          </section>
          <section class="all-y4M48UwqUx8k8i chat-y4M48UwqUx8k8i" id="chat-y4M48UwqUx8k8i">
            <div id="chat__inner-y4M48UwqUx8k8i" class="all-y4M48UwqUx8k8i"></div>
          </section>
          <div id="chat-input-container-y4M48UwqUx8k8i" class="all-y4M48UwqUx8k8i p-4-y4M48UwqUx8k8i border-t-y4M48UwqUx8k8i border-gray-200-y4M48UwqUx8k8i">
          <div class="all-y4M48UwqUx8k8i flex-y4M48UwqUx8k8i space-x-4-y4M48UwqUx8k8i items-centery-y4M48UwqUx8k8i">
              <input type="text" id="chat-input-y4M48UwqUx8k8i" class="all-y4M48UwqUx8k8i flex-1-y4M48UwqUx8k8i border-y4M48UwqUx8k8i border-gray-300-y4M48UwqUx8k8i rounded-md-y4M48UwqUx8k8i px-4-y4M48UwqUx8k8i py-2-y4M48UwqUx8k8i outline-none-y4M48UwqUx8k8i w-34-y4M48UwqUx8k8i" placeholder="${text[lang]['type']}">
              <button id="chat-submit-y4M48UwqUx8k8i" class="all-y4M48UwqUx8k8i rounded-md-y4M48UwqUx8k8i px-4-y4M48UwqUx8k8i py-2-y4M48UwqUx8k8i cursor-pointer-y4M48UwqUx8k8i">${text[lang]['send']}</button>
              <button id="chat-copy-y4M48UwqUx8k8i" class="all-y4M48UwqUx8k8i rounded-md-y4M48UwqUx8k8i px-4-y4M48UwqUx8k8i py-2-y4M48UwqUx8k8i cursor-pointer-y4M48UwqUx8k8i w-full-y4M48UwqUx8k8i">${text[lang]['copychat']}</button>
              <button id="chat-new-y4M48UwqUx8k8i" class="all-y4M48UwqUx8k8i rounded-md-y4M48UwqUx8k8i px-4-y4M48UwqUx8k8i py-2-y4M48UwqUx8k8i cursor-pointer-y4M48UwqUx8k8i w-full-y4M48UwqUx8k8i">${text[lang]['newchat']}</button>
          </div>
          <div class="all-y4M48UwqUx8k8i flex-y4M48UwqUx8k8i text-center-y4M48UwqUx8k8i text-xs-y4M48UwqUx8k8i pt-4-y4M48UwqUx8k8i">
              <!-span class="flex-1-y4M48UwqUx8k8i"></span-->
          </div>
        </div>
        </div>
      `;

      // Add event listeners
      chatInput    = document.getElementById('chat-input-y4M48UwqUx8k8i');
      chatSubmit   = document.getElementById('chat-submit-y4M48UwqUx8k8i');
      chatCopy     = document.getElementById('chat-copy-y4M48UwqUx8k8i');
      chatNew      = document.getElementById('chat-new-y4M48UwqUx8k8i');
      chatMessages = document.getElementById('chat__inner-y4M48UwqUx8k8i');
      chatBubble   = document.getElementById('chat-bubble-y4M48UwqUx8k8i');
      chatPopup    = document.getElementById('chat-popup-y4M48UwqUx8k8i');
      closePopup   = document.getElementById('close-popup-y4M48UwqUx8k8i');

      chatCopy.style.display='none';
      chatNew.style.display='none';

      chatCopy.addEventListener('click', function() {
          transcribeClipboard();
      });

      chatNew.addEventListener('click', function() {
          newChat();
      });

      chatSubmit.addEventListener('click', function() {
          const message = chatInput.value.trim();
          if (!message) return;
          chatMessages.scrollTop = chatMessages.scrollHeight;
          chatInput.value = '';
          onUserRequest(message);
      });

      chatInput.addEventListener('keyup', function(event) {
          if (event.key === 'Enter') {
              chatSubmit.click();
          }
      });

      chatBubble.addEventListener('click', function() {
          togglePopup();
      });

      closePopup.addEventListener('click', function() {
          togglePopup();
      });

      var form = document.getElementById('chat-y4M48UwqUx8k8i');
      form.addEventListener("submit", send);
      var cform = document.getElementById('contactform-y4M48UwqUx8k8i');
      cform.addEventListener("submit", contactsend);
  }


  function refresh_messages(e) {
      if(e.action=='create') {
          if(e.record.direction=='outbound' || e.record.direction=='autoreply' || e.record.direction=='csat1' || e.record.direction=='csat2') {
              blip.play();
              reply(e.record.body,true);
          } else if(e.record.direction=='info') {
              if(e.record.body.indexOf('Closed by')===0) {
                  closeChat();
              }
          }
      }
  }

  function togglePopup() {
      const chatPopup = document.getElementById('chat-popup-y4M48UwqUx8k8i');
      if(chat_disabled==1) {
          return;
      } else {
          chatPopup.classList.toggle('hidden-y4M48UwqUx8k8i');
          if (!chatPopup.classList.contains('hidden-y4M48UwqUx8k8i')) {
              document.getElementById('chat-input-y4M48UwqUx8k8i').focus();
          }
      }
  }

  function connect_subscribe(userid,domain) {
      fingerprint = userid;
      const pb = new PocketBase(realtime_url);
      pb.authStore.storageKey = "webchat_auth"; // to avoid collitions with fop2
      pb.collection('users').authWithPassword(fingerprint+'@webuser_'+domain+page+'_'+fingerprint+'.noemail',fingerprint+'').then((authData)=> {
          if(pb.authStore.isValid) {
              pb.collection('messages').subscribe('*', function (e) {
                  refresh_messages(e);
              });
              const pageResult = pb.collection('incomingqueue').getList(1, 500, {
                  filter: 'state="assigned"||state="open"||state="bot"'
              }).then((pageResult) => {
                  if(pageResult.items.length > 0) {
                      const msgResult = pb.collection('messages').getFullList(200, {sort: 'created', filter: 'conversation="'+pageResult.items[0].id+'"'}).then((msgResult)=> {
                          msgResult.forEach(msg => {
                              if(msg.direction=='inbound' || msg.direction=='outbound' || msg.direction=='autoreply') {
                                      if(msg.direction=='outbound') {
                                          reply(msg.body,false);
                                      } else {
                                          printmsg(msg.body);
                                      }
                                 }
                          })
                      })
                  }
              })
          }
      })
  }

  function onUserRequest(message) {
      // Display user message
      const messageElement = document.createElement('div');
      messageElement.className = 'chat__message-y4M48UwqUx8k8i chat__message_B-y4M48UwqUx8k8i';
      messageElement.innerHTML = `
        <div class="chat__content-y4M48UwqUx8k8i"><p>
          ${message}
          </p>
        </div>
      `;
      chatMessages.appendChild(messageElement);
      chatMessages.scrollTop = chatMessages.scrollHeight;
      chatInput.value = '';
      data = { newmsg: message, id: fingerprint, page: page, name: name, email: email };
      fetch(hook_path+'/helper.php', {
          method: 'POST',
          body: JSON.stringify(data)
      })
      .then(response=>response.json())
      .then(function(response) {
          console.log(response);
      });
  }

  function printmsg(message) {
      cmdresult = removeCloseIndicator(message)
      brmessage = cmdresult.modifiedString.replace(/(?:\r\n|\r|\n)/g, '<br>');

      if(cmdresult.modifiedString!='') {
          const chatMessages = document.getElementById('chat__inner-y4M48UwqUx8k8i');
          const messageElement = document.createElement('div');
          messageElement.className = 'chat__message-y4M48UwqUx8k8i chat__message_B-y4M48UwqUx8k8i';
          messageElement.innerHTML = `
            <div class="chat__content-y4M48UwqUx8k8i"><p>
              ${message}
              </p>
            </div>
          `;
          chatMessages.appendChild(messageElement);
          chatMessages.scrollTop = chatMessages.scrollHeight;
          chatInput.value = '';
      }
  };

  function reply(message,interpretCommand) {

      cmdresult = removeCloseIndicator(message)
      brmessage = cmdresult.modifiedString.replace(/(?:\r\n|\r|\n)/g, '<br>');

      if(cmdresult.modifiedString!='') {
          const chatMessages = document.getElementById('chat__inner-y4M48UwqUx8k8i');
          const replyElement = document.createElement('div');
          replyElement.className = 'chat__message-y4M48UwqUx8k8i chat__message_A-y4M48UwqUx8k8i';
          replyElement.innerHTML = `
            <div class="chat__content-y4M48UwqUx8k8i"><p>
              ${brmessage}</p>
            </div>
          `;
          chatMessages.appendChild(replyElement);
          chatMessages.scrollTop = chatMessages.scrollHeight;
      }

      if(cmdresult.closePresent==true && interpretCommand==true) {
          closeChat();
      }
  }

  function newChat() {
      chatMessages.style.opacity='1';
      chatSubmit.disabled=false;
      chatSubmit.style.display='block';
      chatInput.disabled=false;
      chatInput.style.opacity='';
      chatInput.style.display='block';
      chatCopy.style.display='none';
      chatNew.style.display='none';

      while (chatMessages.firstChild) {
        chatMessages.removeChild(chatMessages.firstChild);
      }
  }

  function closeChat() {
      chatMessages.style.opacity='.5';
      chatSubmit.disabled=true;
      chatSubmit.style.display='none';
      chatInput.disabled=true;
      chatInput.style.opacity='.5';
      chatInput.style.display='none';
      chatCopy.style.display='block';
      chatNew.style.display='block';
  }

  function contactsend(event) {
      // submit contact form/info
      email = document.getElementById('email-y4M48UwqUx8k8i').value;
      name = document.getElementById('fullname-y4M48UwqUx8k8i').value;
      event.preventDefault();
      data = { addcontact: 1, email: email, name: name, id: fingerprint, page: page };
      fetch(hook_path+'/helper.php', {
          method: 'POST',
          body: JSON.stringify(data)
      })
      .then(response=>response.json())
      .then(function(response) {
          console.log(response);
          if(response.id!='') {
              document.getElementById('contact-y4M48UwqUx8k8i').style.display = 'none';
              document.getElementById('chat-y4M48UwqUx8k8i').style.display = 'flex';
              document.getElementById('chat-input-container-y4M48UwqUx8k8i').style.display = 'block';
              connect_subscribe(response.id,response.domain);
          }
      });
  }

  function send(event) {
      // send message
      var text = document.getElementById('msg').value;
      event.preventDefault();

      data = { newmsg: text, id: fingerprint, page: page, name: name, email: email };
      fetch(hook_path+'/helper.php', {
          method: 'POST',
          body: JSON.stringify(data)
      })
      .then(response=>response.json())
      .then(function(response) {
          console.log(response);
      });
  }

  function removeCloseIndicator(inputString) {
    const closeIndicator = /\[close\]/;
    const closePresent = closeIndicator.test(inputString);
    const modifiedString = inputString.replace(closeIndicator, '');
    return { modifiedString, closePresent };
  }

  function transcribeClipboard() {
    const chatContainer = document.getElementById("chat__inner-y4M48UwqUx8k8i");

    // Initialize an empty string to store the combined chat messages
    let chatText = "";

    // Iterate through each chat message
    const chatMessages = chatContainer.querySelectorAll(".chat__message-y4M48UwqUx8k8i");
    chatMessages.forEach((chatMessage) => {
      // Get the text content of the chat message
      const messageText = chatMessage.querySelector(".chat__content-y4M48UwqUx8k8i p").textContent.trim();
      const className = chatMessage.className;
      if (className.includes("chat__message_A")) {
          who = text[lang]['agent'];
      } else {
          who = text[lang]['you'];
      }

      // Add the message text to the combined chat text
      chatText += who+": "+messageText + '\n';
    });

    // Copy the combined chat text to the clipboard
    const textArea = document.createElement("textarea");
    textArea.value = chatText;
    document.body.appendChild(textArea);
    textArea.select();
    document.execCommand('copy');
    document.body.removeChild(textArea);
  }

}( window.fop2chatbroker = window.fop2chatbroker || {} ));
