<?php
header("Access-Control-Allow-Origin: *"); // Replace "*" with specific origins if needed
header("Access-Control-Allow-Methods: GET, POST, OPTIONS"); // Specify the allowed HTTP methods
header("Access-Control-Allow-Headers: Content-Type"); // Specify the allowed request headers

require_once("../menu/chatbroker.class.".PHP_MAJOR_VERSION.".php");

$partes_dir = preg_split("/\//",dirname(__FILE__));
array_pop($partes_dir);
array_pop($partes_dir);
array_pop($partes_dir);
$final = '/'.join("/",$partes_dir);
chdir($final);
require_once("config.php");
require_once("functions.php");
require_once("dblib.php");
require_once("asmanager.php");
require_once("system.php");
require_once("dbconn.php");

if ($_SERVER["REQUEST_METHOD"] === "OPTIONS") {
    exit(); // Return early for OPTIONS requests to avoid further processing
}

$chatbroker_dir = "/var/www/html/fop2/admin/plugins/phonepro/menu";
require_once($chatbroker_dir."/chatbroker.class.".PHP_MAJOR_VERSION.".php");
$cb   = new ChatBroker(array());

$json = file_get_contents('php://input');
$data = json_decode($json,1);

if(isset($data['newchat'])) {

    $page = $data['page'];
    $ret = $cb->get_provider_config("webchat",$data['page']);
    $tenant_context = $ret['context'];
    if($tenant_context===null) {
        $tenant_context='';
    }
    $template_config = json_decode($ret['chatbroker_template'],1);
    $valid_referer = $template_config['URL'];
    check_referer($valid_referer);

    if($tenant_context!='') {
        $tenant_context=$tenant_context."_";
    }

    $webmailDomain = "webuser_".$tenant_context.$page."_".$data['newchat'];
    $finalDomain = strtolower($webmailDomain);

    $ret = $cb->get_pb_webuser($data['newchat'],$finalDomain);
    if(count($ret['items'])==0) {
        //$userid = $cb->add_pb_user($data['newchat'],$data['newchat'],$finalDomain);
        echo "{\"id\":\"none\"}";
        exit;
    } else {
        $userid     = $ret['items'][0]['id'];
        $name_email = $ret['items'][0]['name'];
        $partes     = preg_split("/~/",$name_email);
        $name       = $partes[0];
        $email      = $partes[1];
    }
    $response = array("id"=>$data['newchat'], "domain"=>$tenant_context, "name"=>$name, "email"=>$email);
    echo json_encode($response);
    exit;

} elseif(isset($data['addcontact'])) {

    $page = $data['page'];
    $ret = $cb->get_provider_config("webchat",$data['page']);
    $tenant_context = $ret['context'];

    $template_config = json_decode($ret['chatbroker_template'],1);
    $valid_referer = $template_config['URL'];
    check_referer($valid_referer);

    if($tenant_context!='') {
        $tenant_context=$tenant_context."_";
    }
    $webmailDomain = "webuser_".$tenant_context.$page."_".$data['id'];
    $finalDomain = strtolower($webmailDomain);

    $userid = $cb->add_pb_user($data['id'],$data['id'],$finalDomain,$data['name']."~".$data['email']);
    echo "{\"id\":\"${data['id']}\",\"domain\":\"$tenant_context\"}";

} elseif(isset($data['newmsg'])) {

    $fromid = $data['id'];
    $body   = $data['newmsg'];
    $page   = $data['page'];
    $name   = $data['name'];
    $email  = $data['email'];

    $ret = $cb->get_provider_config("webchat",$page);
    $template_config = json_decode($ret['chatbroker_template'],1);
    $valid_referer = $template_config['URL'];
    check_referer($valid_referer);

    if($name=='' && $email!='') { 
        $from=$email;
    } else if($name!='' && $email=='') {
        $from=$name;
    } else if($name!='' && $email!='') {
        $from=$name;
    } else {
        $from=$fromid;
    }

    $extra_data = $data;
    unset($extra_data['newmsg']);
    unset($extra_data['id']);
    unset($extra_data['page']);
    unset($extra_data['name']);
    $j_extra_data = base64_encode(json_encode($extra_data));

    $actual_path = (empty($_SERVER['HTTPS']) ? 'http' : 'https') . "://localhost$_SERVER[REQUEST_URI]";
    $url = dirname($actual_path)."/../menu/hook.php?webchat=1";
    $ch = curl_init();
    $post_data="from=$from&to=$page&body=$body&fromid={$fromid}&extra={$j_extra_data}";
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_VERBOSE, 0);
    $server_output = curl_exec($ch);
    curl_close($ch);
    echo "{\"status\":\"ok\"}";
}

function check_referer($ref) {
    $request_referer = $_SERVER['HTTP_REFERER'];
    if(!preg_match("/$ref/i",$request_referer)) {
        echo "{\"status\":\"forbidden\"}";
        exit;
    }
}
